]> git.sesse.net Git - backup.sh/blob - backup.sh
Delete lockfile on abort; we should try again automatically next night.
[backup.sh] / backup.sh
1 #!/bin/bash
2 # backup.sh
3
4 # Backup up Unix-like computers
5
6 # itk@samfundet.no
7 #
8 # This script was first checked into RCS in 2000, and has since backed up a few
9 # servers almost every day, whenever not broken.
10
11 # It's a bit peculiar, but quite effective. The following is worth keeping in
12 # mind when hacking:
13 #
14 # KISS. And by that I mean really simple. Only regular Unix commands, please
15 # (but GNU extensions are used and moreutils has to be installed).
16 #
17 # Because of the way we run this script from cron, informational logging goes
18 # to stderr and warnings and errors to stdout. This way, we get mail whenever
19 # stuff fails, and other output is redirected to the log file.
20
21 # The script is halfway Norwegian and halfway English. Newer modifications are
22 # in English, we should probably stick to that.
23
24 # The computer to backup.
25 computer=$1
26
27 # Configuration
28 LOCKFILE=/home/backup/backuprun.lockfile.$computer
29 confdir=/home/backup/conf/              # Configuration files
30 storagedir=/backup                      # Where we keep backups
31 maxnumfull=3                            # Number of full backups
32 daysbetweenfull=30                      # Days between full backups
33 daysbetweenfullforfixed=32              # Days between full backups for machines with fixed
34                                         # full-backup date (in case the fixed day gets missed)
35 DAY_OF_MONTH=`date "+%d" | sed s/^0//`  # from 1 to 31
36 DATE=`date "+%Y%m%d%H%M"`               #format: touch
37 DATEs=`date "+%Y-%m-%d %H:%M"`          #format: tar
38
39 # Exclude-pattern
40 exclude=$confdir/exclude
41 [ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
42
43 if [ -z "$computer" ]; then
44         echo "Usage: $0 COMPUTER"
45         exit 1
46 fi
47
48 # Die more or less gracefully (at least notify user)
49 die() {
50         echo `date`": Something nasty happened."
51         rm $LOCKFILE
52         exit 1
53 }
54
55 # Trap C-c and kill
56 trap die SIGINT SIGTERM
57
58 # Don't start if we're already running
59 if [ -e $LOCKFILE ]; then
60         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting."
61         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting." >&2
62         exit 1
63 fi;
64 touch $LOCKFILE
65 echo $$ > $LOCKFILE
66
67 echo `date`": Backup run starting" >&2
68
69 umask 027
70
71
72 backup()
73 {
74         echo -n `date` >&2
75         printf " $computer: $computer:$filesystem $backuplevel backup\n" >&2
76
77         SNARFILE="${storagedir}/${computer}/${sfilesystem}/.incremental.snar"
78         incrementalsnar="/root/.backup/${sfilesystem}.snar"
79         if [ "$backuplevel" = "daglig" ]
80         then
81                 # If incremental backup, we need to copy the incremental status to $computer.
82                 # If it does not exist, whine a bit and then run date-based instead.
83                 if [ -s "$SNARFILE" ]; then
84                         if ! scp $SNARFILE root@$computer:$incrementalsnar; then
85                                 echo `date`" $computer: Could not copy .incremental.snar to $computer"
86                                 die
87                         fi
88                         lastcmd="--listed-incremental=$incrementalsnar --no-check-device"
89                 else
90                         echo `date`" $computer: Missing incremental.snar for $filesystem, doing date-based backup instead until next full backup" >&2
91                         incrementalsnar=""
92                         lastd=`cat ../.date`
93                         lastcmd="--newer='$lastd'"
94                 fi
95         else
96                 lastcmd="--listed-incremental=$incrementalsnar"
97         fi
98
99         # expand the exclude-path for use with tar
100         exf=`ssh root@$computer "ls ~/.backup/exclude"`
101
102         # We try to run tar on the remote computer
103         #    c create archive
104         #    C change to directory first
105         #    . where to start taring (see C)
106         #    $lastcmd only files newer than this
107         #    --one-file-system don't traverse file systems
108         #    --use-compress-program compress it using gzip or pigz
109         #    --exclude-from file to get exclusion pattern from
110         #    Pipe the stuff over ssh to ourselves, run pee to cat the contents to a
111         #    file and build a file list, respectivly.  
112         TARFILE=$DATE.tmp
113         TARCMD="ssh root@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
114                 --exclude-from=$exf\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
115         echo `date`" $computer: Running $TARCMD" >&2
116         eval $TARCMD > $DATE.idx
117
118         if [ $? -eq 0 ] && [ -s $TARFILE ]; then
119                 # File is >0 in size and neither cat or tar tzvf failed; we assume it worked.
120
121                 if ! scp root@$computer:$incrementalsnar $SNARFILE.tmp; then
122                         echo `date`" $computer: Could not copy .incremental.snar from $computer"
123                         die
124                 fi
125
126                 # Move tar file in place
127                 mv $TARFILE $DATE.tgz
128                 mv $SNARFILE.tmp $SNARFILE
129
130                 # Update timestamp
131                 echo $DATEs > ../.date && touch -t $DATE ../.date
132
133                 # Make a sorted file list as well
134                 sort -k6 < $DATE.idx > $DATE.sdx
135
136                 # Fix permissions
137                 chmod 600 *tgz                      #only for us
138                 chmod 644 *sdx *idx 2>/dev/null     #everyone can read
139
140                 # Let the remote computer know that we ran a successful backup (for nagios)
141                 ssh root@$computer touch $filesystem/.lastbackup
142         else
143                 # Something wrong happened.
144                 rm $TARFILE
145                 echo `date`" $computer: $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
146                 die
147         fi
148 }
149
150 # Check that the target filesystem is mounted (actually check that it's not
151 # the root filesystem)
152 if [ ! -d "$storagedir/$computer" ]; then
153         echo `date`" $computer: Target filesystem ($storagedir/$computer) does not exist. Aborting"
154         die
155 fi
156 rootfilesystem=`df -P /`
157 targetfilesystem=`df -P "$storagedir/$computer"`
158 if [ "$rootfilesystem" == "$targetfilesystem" ]; then
159         echo `date`" $computer: Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
160         die
161 fi
162
163 echo `date`" $computer: Backing up $computer" >&2
164
165 # Try to SSH to the computer without entering a password.
166 if ! `ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true`; then
167         echo `date`" $computer: Could not use passwordless SSH."
168         die
169 fi
170
171 # Check if pigz is available
172 if ssh -n root@$computer "pigz -V 2>/dev/null"; then
173         compressor=pigz
174 else
175         echo `date`" $computer: pigz missing; falling back to gzip."
176         compressor=gzip
177 fi
178
179 # Check dump bit in fstab
180 filesystems=`ssh -n root@$computer "cat /etc/fstab" \
181         | grep -v nfs \
182         | grep -v "^#" \
183         | grep -v "^$" \
184         | awk '{ if ( $(NF-1) != "0" ) print $2}' `
185
186 # Clean up our dir at this client
187 if ! ssh root@$computer "rm -r ~/.backup ; mkdir -m 700 ~/.backup"; then
188         echo `date`" $computer: Could not create backup staging area at $computer:~/.backup"
189         die
190 fi
191
192 # Try to copy $exclude to $computer
193 if ! scp $exclude root@$computer:~/.backup/exclude > /dev/null; then
194         echo `date`" $computer: Could not copy exclude.txt to $computer"
195         die
196 fi
197
198 # Try to copy preeexec and postexec if they exist
199 if [ -f $confdir/preexec.$computer ]; then
200         if ! scp $confdir/preexec.$computer  root@$computer:~/.backup/preexec >&2; then
201                 echo `date`" $computer: Could not copy preexec.$computer to $computer:~/.backup/preexec"
202                 die
203         fi
204 fi
205 if [ -f $confdir/postexec.$computer ]; then
206         if ! scp $confdir/postexec.$computer root@$computer:~/.backup/postexec >&2; then
207                 echo `date`" $computer: Could not copy postexec.$computer to $computer:~/.backup/postexec"
208                 die
209         fi
210 fi
211
212 # Try to run preexec if it exists
213 if ! ssh root@$computer "[ ! -f ~/.backup/preexec ] || /bin/bash -x ~/.backup/preexec" >&2; then
214         echo `date`" $computer: Could not run $computer:~/.backup/preexec"
215         die
216 fi
217
218 for filesystem in $filesystems
219 do
220         # Remove / and $ (for Windows) for path names
221         sfilesystem=`echo $filesystem | tr '\/\$' '__'`
222
223         # Prepare storage area
224         mkdir -m 755 -p $storagedir/$computer/$sfilesystem/full 2>/dev/null
225         mkdir -m 755 -p $storagedir/$computer/$sfilesystem/daglig 2>/dev/null
226
227         # Default backuplevel
228         backuplevel=daglig
229
230         if [ ! -f $storagedir/$computer/$sfilesystem/.date ]
231         then
232                 # Take the first full backup of this filesystem on this computer
233                 backuplevel=full
234                 echo $DATEs > $storagedir/$computer/$sfilesystem/.date
235         fi
236
237         # Check if we want a full backup
238         if [ -f $confdir/fastfullbackupdag.$computer.$sfilesystem ]; then
239                 fullbackup_min_for_this_machine=$daysbetweenfullforfixed
240                 if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer.$sfilesystem`" ]; then
241                         backuplevel=full
242                 fi
243         elif [ -f $confdir/fastfullbackupdag.$computer ]; then
244                 fullbackup_min_for_this_machine=$daysbetweenfullforfixed
245                 if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer`" ]; then
246                         backuplevel=full
247                 fi
248         else
249                 fullbackup_min_for_this_machine=$daysbetweenfull 
250         fi
251
252         if [ -z "`find $storagedir/$computer/$sfilesystem/full/ -name \*tgz -mtime -$fullbackup_min_for_this_machine`" ]; then
253                 backuplevel=full
254         fi
255
256         # We want to be here
257         cd $storagedir/$computer/$sfilesystem/$backuplevel || die
258
259         # Perform the actual backup
260         backup
261
262         # Check if this box has a custom number of full backups
263         if [ -f $confdir/maksfulle.$computer ] ; then
264                 mf=$((`cat $confdir/maksfulle.$computer`+1))
265         else
266                 mf=$(($maxnumfull+1))
267         fi
268
269         # Delete old full backups
270         for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`
271         do
272                 prefix=`echo $full | sed "s/\.[^.]*$//"`
273                 echo `date`": $computer:$filesystem Deleting full backup $prefix" >&2
274                 rm $prefix*
275         done
276
277         # Delete incremental backups older than the oldest full backup
278         oldf=`ls -t1 $storagedir/$computer/$sfilesystem/full/*tgz | tail -1`
279         find \
280                 $storagedir/$computer/$sfilesystem/daglig \
281                 -type f \
282                 \! -newer $oldf \
283                 -printf "`date`: $computer: Deleting old incremental backup: %p\n" \
284                 -exec rm {} \; >&2
285 done
286
287 # Try to run postexec if it exist
288 if ! ssh root@$computer "[ ! -f ~/.backup/postexec ] || /bin/bash -x ~/.backup/postexec" >&2; then
289         echo `date`" $computer: Could not run $computer:~/.backup/postexec"
290         die
291 fi
292
293 # Remove lockfile
294 rm $LOCKFILE